VTK: vtkMappedUnstructuredGrid< Implementation, CellIterator > Class Template Reference

| VTK 9.3.1

Public Types | Public Member Functions | Protected Types | Protected Member Functions | Protected Attributes | List of all members
vtkMappedUnstructuredGrid< Implementation, CellIterator > Class Template Reference

Allows datasets with arbitrary storage layouts to be used with VTK. More...

`#include <vtkMappedUnstructuredGrid.h>`

Inheritance diagram for vtkMappedUnstructuredGrid< Implementation, CellIterator >:
[legend]
Collaboration diagram for vtkMappedUnstructuredGrid< Implementation, CellIterator >:
[legend]

## Public Types
typedef Implementation | ImplementationType
typedef CellIterator | CellIteratorType
Public Types inherited from vtkPointSet
typedef vtkDataSet | Superclass
| Standard methods for type information and printing. More...
Public Types inherited from vtkDataSet
enum | FieldDataType { DATA_OBJECT_FIELD = 0 , POINT_DATA_FIELD = 1 , CELL_DATA_FIELD = 2 }
typedef vtkDataObject | Superclass
Public Types inherited from vtkDataObject
enum | FieldAssociations { FIELD_ASSOCIATION_POINTS , FIELD_ASSOCIATION_CELLS , FIELD_ASSOCIATION_NONE , FIELD_ASSOCIATION_POINTS_THEN_CELLS , FIELD_ASSOCIATION_VERTICES , FIELD_ASSOCIATION_EDGES , FIELD_ASSOCIATION_ROWS , NUMBER_OF_ASSOCIATIONS }
| Possible values for the FIELD_ASSOCIATION information entry. More...
enum | AttributeTypes { POINT , CELL , FIELD , POINT_THEN_CELL , VERTEX , EDGE , ROW , NUMBER_OF_ATTRIBUTE_TYPES }
| Possible attribute types. More...
enum | FieldOperations { FIELD_OPERATION_PRESERVED , FIELD_OPERATION_REINTERPOLATED , FIELD_OPERATION_MODIFIED , FIELD_OPERATION_REMOVED }
| Possible values for the FIELD_OPERATION information entry. More...
typedef vtkObject | Superclass

## Public Member Functions
| vtkTemplateTypeMacro (SelfType, vtkUnstructuredGridBase)
void | PrintSelf (ostream &os, vtkIndent indent) override
| Methods invoked by print to print information about the object including superclasses. More...
void | CopyStructure (vtkDataSet *pd) override
| Copy the geometric and topological structure of an object. More...
void | ShallowCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
vtkIdType | GetNumberOfCells () override
| Determine the number of cells composing the dataset. More...
vtkCell * | GetCell (vtkIdType cellId) override
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
void | GetCell (vtkIdType cellId, vtkGenericCell *cell) override
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
int | GetCellType (vtkIdType cellId) override
| Get type of cell with cellId such that: 0 <= cellId < NumberOfCells. More...
void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds) override
| Topological inquiry to get points defining cell. More...
vtkCellIterator * | NewCellIterator () override
| Return an iterator that traverses the cells in this data set. More...
void | GetPointCells (vtkIdType ptId, vtkIdList *cellIds) override
| Topological inquiry to get cells using point. More...
int | GetMaxCellSize () override
| Convenience method returns largest cell size in dataset. More...
void | GetIdsOfCellsOfType (int type, vtkIdTypeArray *array) override
| Fill vtkIdTypeArray container with list of cell Ids. More...
int | IsHomogeneous () override
| Traverse cells and determine if cells are all of the same type. More...
void | Allocate (vtkIdType numCells, int extSize=1000) override
| Allocate memory for the number of cells indicated. More...
vtkMTimeType | GetMTime () override
| Datasets are composite objects and need to check each part for MTime THIS METHOD IS THREAD SAFE. More...
void | SetImplementation (ImplementationType *impl)
ImplementationType * | GetImplementation ()
virtual vtkCell * | GetCell (vtkIdType cellId)=0
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual vtkCell * | GetCell (int vtkNotUsed(i), int vtkNotUsed(j), int vtkNotUsed(k))
virtual void | GetCell (vtkIdType cellId, vtkGenericCell *cell)=0
| Get cell with cellId such that: 0 <= cellId < NumberOfCells. More...
Public Member Functions inherited from vtkUnstructuredGridBase
| vtkAbstractTypeMacro (vtkUnstructuredGridBase, vtkPointSet)
void | PrintSelf (ostream &os, vtkIndent indent) override
| Standard methods for type information and printing. More...
int | GetDataObjectType () override
| Standard vtkDataSet API methods. More...
void | DeepCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
vtkIdType | InsertNextCell (int type, vtkIdType npts, const vtkIdType ptIds[])
| Insert/create cell in object by type and list of point ids defining cell topology. More...
vtkIdType | InsertNextCell (int type, vtkIdList *ptIds)
| Insert/create cell in object by a list of point ids defining cell topology. More...
vtkIdType | InsertNextCell (int type, vtkIdType npts, const vtkIdType ptIds[], vtkIdType nfaces, const vtkIdType faces[])
void | ReplaceCell (vtkIdType cellId, int npts, const vtkIdType pts[])
| Replace the points defining cell "cellId" with a new set of points. More...
Public Member Functions inherited from vtkPointSet
void | Initialize () override
| Reset to an empty state and free any memory. More...
void | CopyStructure (vtkDataSet *pd) override
| Copy the geometric structure of an input point set object. More...
vtkCell * | GetCell (vtkIdType) override
| This method always return a `vtkEmptyCell`, as there is no cell in a `vtkPointSet`. More...
void | GetCell (vtkIdType, vtkGenericCell *cell) override
| This method sets cell to be an empty cell. More...
int | GetCellType (vtkIdType) override
| This method always returns `VTK_EMPTY_CELL`, as there is no cell in a `vtkPointSet`. More...
vtkIdType | GetCellSize (vtkIdType) override
| This method always returns 1, as all cells are point in a pure `vtkPointSet`. More...
double * | GetPoint (vtkIdType ptId) override
| See vtkDataSet for additional information. More...
vtkCellIterator * | NewCellIterator () override
| Return an iterator that traverses the cells in this data set. More...
void | BuildCellLocator ()
| Build the cell locator. More...
vtkMTimeType | GetMTime () override
| Get MTime which also considers its vtkPoints MTime. More...
void | ComputeBounds () override
| Compute the (X, Y, Z) bounds of the data. More...
void | Squeeze () override
| Reclaim any unused memory. More...
unsigned long | GetActualMemorySize () override
| Return the actual size of the data in kibibytes (1024 bytes). More...
virtual void | SetEditable (bool)
| Specify whether this dataset is editable after creation. More...
virtual bool | GetEditable ()
| Specify whether this dataset is editable after creation. More...
virtual void | EditableOn ()
| Specify whether this dataset is editable after creation. More...
virtual void | EditableOff ()
| Specify whether this dataset is editable after creation. More...
vtkIdType | GetNumberOfPoints () override
| See vtkDataSet for additional information. More...
void | GetPoint (vtkIdType ptId, double x[3]) override
| See vtkDataSet for additional information. More...
vtkIdType | FindPoint (double x[3]) override
| See vtkDataSet for additional information. More...
vtkIdType | FindPoint (double x, double y, double z)
| See vtkDataSet for additional information. More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| See vtkDataSet for additional information. More...
vtkIdType | FindCell (double x[3], vtkCell *cell, vtkGenericCell *gencell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights) override
| See vtkDataSet for additional information. More...
vtkIdType | GetNumberOfCells () override
| This method always returns 0, as there are no cells in a `vtkPointSet`. More...
int | GetMaxCellSize () override
| This method always returns 0, as there are no cells in a `vtkPointSet`. More...
void | GetCellPoints (vtkIdType, vtkIdList *idList) override
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
void | GetPointCells (vtkIdType, vtkIdList *idList) override
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdList *ptIds)=0
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| This method resets parameter idList, as there is no cell in a `vtkPointSet`. More...
void | BuildPointLocator ()
| Build the internal point locator . More...
void | BuildLocator ()
| Build the internal point locator . More...
virtual void | SetPointLocator (vtkAbstractPointLocator *)
| Set / get an instance of vtkAbstractPointLocator which is used to support the FindPoint() and FindCell() methods. More...
virtual vtkAbstractPointLocator * | GetPointLocator ()
| Set / get an instance of vtkAbstractPointLocator which is used to support the FindPoint() and FindCell() methods. More...
virtual void | SetCellLocator (vtkAbstractCellLocator *)
| Set / get an instance of vtkAbstractCellLocator which may be used when a vtkCellLocatorStrategy is used during a FindCell() operation. More...
virtual vtkAbstractCellLocator * | GetCellLocator ()
| Set / get an instance of vtkAbstractCellLocator which may be used when a vtkCellLocatorStrategy is used during a FindCell() operation. More...
virtual void | SetPoints (vtkPoints *)
| Specify point array to define point coordinates. More...
virtual vtkPoints * | GetPoints ()
| Specify point array to define point coordinates. More...
void | ShallowCopy (vtkDataObject *src) override
| Shallow and Deep copy. More...
bool | UsesGarbageCollector () const override
| Overwritten to handle the data/locator loop. More...
virtual vtkTypeBool | IsA (const char *type)
| Standard methods for type information and printing. More...
vtkPointSet * | NewInstance () const
| Standard methods for type information and printing. More...
Public Member Functions inherited from vtkDataSet
vtkDataSet * | NewInstance () const
virtual void | CopyAttributes (vtkDataSet *ds)
| Copy the attributes associated with the specified dataset to this instance of vtkDataSet. More...
virtual vtkCell * | GetCell (int vtkNotUsed(i), int vtkNotUsed(j), int vtkNotUsed(k))
void | SetCellOrderAndRationalWeights (vtkIdType cellId, vtkGenericCell *cell)
virtual void | GetCellBounds (vtkIdType cellId, double bounds[6])
| Get the bounds of the cell with cellId such that: 0 <= cellId < NumberOfCells. More...
virtual void | GetCellTypes (vtkCellTypes *types)
| Get a list of types of cells in a dataset. More...
virtual void | GetCellPoints (vtkIdType cellId, vtkIdType &npts, vtkIdType const *&pts, vtkIdList *ptIds)
| Topological inquiry to get points defining cell. More...
virtual void | GetCellNeighbors (vtkIdType cellId, vtkIdList *ptIds, vtkIdList *cellIds)
| Topological inquiry to get all cells using list of points exclusive of cell specified (e.g., cellId). More...
int | GetCellNumberOfFaces (vtkIdType cellId, unsigned char &cellType, vtkGenericCell *cell)
| Get the number of faces of a cell. More...
virtual vtkCell * | FindAndGetCell (double x[3], vtkCell *cell, vtkIdType cellId, double tol2, int &subId, double pcoords[3], double *weights)
| Locate the cell that contains a point and return the cell. More...
vtkCellData * | GetCellData ()
| Return a pointer to this dataset's cell data. More...
vtkPointData * | GetPointData ()
| Return a pointer to this dataset's point data. More...
double * | GetBounds ()
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
void | GetBounds (double bounds[6])
| Return a pointer to the geometry bounding box in the form (xmin,xmax, ymin,ymax, zmin,zmax). More...
double * | GetCenter ()
| Get the center of the bounding box. More...
void | GetCenter (double center[3])
| Get the center of the bounding box. More...
double | GetLength ()
| Return the length of the diagonal of the bounding box. More...
double | GetLength2 ()
| Return the squared length of the diagonal of the bounding box. More...
virtual void | GetScalarRange (double range[2])
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
double * | GetScalarRange ()
| Convenience method to get the range of the first component (and only the first component) of any scalars in the data set. More...
int | CheckAttributes ()
| This method checks to see if the cell and point attributes match the geometry. More...
vtkFieldData * | GetAttributesAsFieldData (int type) override
| Returns the attributes of the data object as a vtkFieldData. More...
vtkIdType | GetNumberOfElements (int type) override
| Get the number of elements for a specific attribute type (POINT, CELL, etc.). More...
bool | HasAnyGhostCells ()
| Returns 1 if there are any ghost cells 0 otherwise. More...
bool | HasAnyGhostPoints ()
| Returns 1 if there are any ghost points 0 otherwise. More...
virtual bool | HasAnyBlankCells ()
| Returns 1 if there are any blanking cells 0 otherwise. More...
virtual bool | HasAnyBlankPoints ()
| Returns 1 if there are any blanking points 0 otherwise. More...
vtkUnsignedCharArray * | GetPointGhostArray ()
| Gets the array that defines the ghost type of each point. More...
void | UpdatePointGhostArrayCache ()
| Updates the pointer to the point ghost array. More...
vtkUnsignedCharArray * | AllocatePointGhostArray ()
| Allocate ghost array for points. More...
vtkUnsignedCharArray * | GetCellGhostArray ()
| Get the array that defines the ghost type of each cell. More...
void | UpdateCellGhostArrayCache ()
| Updates the pointer to the cell ghost array. More...
vtkUnsignedCharArray * | AllocateCellGhostArray ()
| Allocate ghost array for cells. More...
vtkUnsignedCharArray * | GetGhostArray (int type) override
| Returns the ghost array for the given type (point or cell). More...
vtkIdType | FindPoint (double x, double y, double z)
| Locate the closest point to the global coordinate x. More...
virtual void | GenerateGhostArray (int zeroExt[6])
| Normally called by pipeline executives or algorithms only. More...
virtual void | GenerateGhostArray (int zeroExt[6], bool cellOnly)
| Normally called by pipeline executives or algorithms only. More...
Public Member Functions inherited from vtkDataObject
vtkDataObject * | NewInstance () const
void | ReleaseData ()
| Release data back to system to conserve memory resource. More...
vtkMTimeType | GetUpdateTime ()
| Used by Threaded ports to determine if they should initiate an asynchronous update (still in development). More...
virtual void | CopyInformationFromPipeline (vtkInformation *vtkNotUsed(info))
| Copy from the pipeline information to the data object's own information. More...
virtual void | CopyInformationToPipeline (vtkInformation *vtkNotUsed(info))
| Copy information from this data object to the pipeline information. More...
void | DataHasBeenGenerated ()
| This method is called by the source when it executes to generate data. More...
virtual void | PrepareForNewData ()
| make the output data ready for new data to be inserted. More...
virtual int | GetExtentType ()
| The ExtentType will be left as VTK_PIECES_EXTENT for data objects such as vtkPolyData and vtkUnstructuredGrid. More...
virtual void | Crop (const int *updateExtent)
| This method crops the data object (if necessary) so that the extent matches the update extent. More...
virtual vtkDataSetAttributes * | GetAttributes (int type)
| Returns the attributes of the data object of the specified attribute type. More...
virtual int | GetAttributeTypeForArray (vtkAbstractArray *arr)
| Retrieves the attribute type that an array came from. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this data object. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this data object. More...
virtual vtkTypeBool | GetDataReleased ()
| Get the flag indicating the data has been released. More...
virtual void | SetFieldData (vtkFieldData *)
| Assign or retrieve a general field data to this data object. More...
virtual vtkFieldData * | GetFieldData ()
| Assign or retrieve a general field data to this data object. More...
void | GlobalReleaseDataFlagOn ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
void | GlobalReleaseDataFlagOff ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Protected Types
typedef vtkMappedUnstructuredGrid< Implementation, CellIterator > | ThisType

## Protected Member Functions
| vtkMappedUnstructuredGrid ()
| ~vtkMappedUnstructuredGrid () override
vtkIdType | InternalInsertNextCell (int type, vtkIdType npts, const vtkIdType ptIds[]) override
vtkIdType | InternalInsertNextCell (int type, vtkIdList *ptIds) override
vtkIdType | InternalInsertNextCell (int type, vtkIdType npts, const vtkIdType ptIds[], vtkIdType nfaces, const vtkIdType faces[]) override
void | InternalReplaceCell (vtkIdType cellId, int npts, const vtkIdType pts[]) override
Protected Member Functions inherited from vtkUnstructuredGridBase
| vtkUnstructuredGridBase ()
| ~vtkUnstructuredGridBase () override
Protected Member Functions inherited from vtkPointSet
| vtkPointSet ()
| ~vtkPointSet () override
void | ReportReferences (vtkGarbageCollector *) override
virtual vtkObjectBase * | NewInstanceInternal () const
| Standard methods for type information and printing. More...
Protected Member Functions inherited from vtkDataSet
| vtkDataSet ()
| ~vtkDataSet () override
virtual void | ComputeScalarRange ()
| Compute the range of the scalars and cache it into ScalarRange only if the cache became invalid (ScalarRangeComputeTime). More...
Protected Member Functions inherited from vtkDataObject
| vtkDataObject ()
| ~vtkDataObject () override
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
vtkSmartPointer< ImplementationType > | Impl
Protected Attributes inherited from vtkPointSet
bool | Editable
vtkPoints * | Points
vtkAbstractPointLocator * | PointLocator
vtkAbstractCellLocator * | CellLocator
Protected Attributes inherited from vtkDataSet
vtkCellData * | CellData
vtkPointData * | PointData
vtkCallbackCommand * | DataObserver
vtkTimeStamp | ComputeTime
double | Bounds [6]
double | Center [3]
double | ScalarRange [2]
vtkTimeStamp | ScalarRangeComputeTime
vtkUnsignedCharArray * | PointGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
vtkUnsignedCharArray * | CellGhostArray
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | PointGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
bool | CellGhostArrayCached
| These arrays pointers are caches used to avoid a string comparison (when getting ghost arrays using GetArray(name)) More...
Protected Attributes inherited from vtkDataObject
vtkFieldData * | FieldData
vtkTypeBool | DataReleased
vtkTimeStamp | UpdateTime
vtkInformation * | Information
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers

## Additional Inherited Members
Static Public Member Functions inherited from vtkUnstructuredGridBase
static vtkUnstructuredGridBase * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkUnstructuredGridBase * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkPointSet
static vtkPointSet * | New ()
| Standard instantiation method. More...
static vtkPointSet * | ExtendedNew ()
static vtkPointSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkPointSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Standard methods for type information and printing. More...
static vtkPointSet * | SafeDownCast (vtkObjectBase *o)
| Standard methods for type information and printing. More...
Static Public Member Functions inherited from vtkDataSet
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataSet * | SafeDownCast (vtkObjectBase *o)
static vtkDataSet * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataSet * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
Static Public Member Functions inherited from vtkDataObject
static vtkDataObject * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkDataObject * | SafeDownCast (vtkObjectBase *o)
static vtkInformation * | GetActiveFieldInformation (vtkInformation *info, int fieldAssociation, int attributeType)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and attribute (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) More...
static vtkInformation * | GetNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Return the information object within the input information object's field data corresponding to the specified association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS) and name. More...
static void | RemoveNamedFieldInformation (vtkInformation *info, int fieldAssociation, const char *name)
| Remove the info associated with an array. More...
static vtkInformation * | SetActiveAttribute (vtkInformation *info, int fieldAssociation, const char *attributeName, int attributeType)
| Set the named array to be the active field for the specified type (SCALARS, VECTORS, NORMALS, TCOORDS, or TENSORS) and association (FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetActiveAttributeInfo (vtkInformation *info, int fieldAssociation, int attributeType, const char *name, int arrayType, int numComponents, int numTuples)
| Set the name, array type, number of components, and number of tuples within the passed information object for the active attribute of type attributeType (in specified association, FIELD_ASSOCIATION_POINTS or FIELD_ASSOCIATION_CELLS). More...
static void | SetPointDataActiveScalarInfo (vtkInformation *info, int arrayType, int numComponents)
| Convenience version of previous method for use (primarily) by the Imaging filters. More...
static const char * | GetAssociationTypeAsString (int associationType)
| Given an integer association type, this static method returns a string type for the attribute (i.e. More...
static int | GetAssociationTypeFromString (const char *associationName)
| Given a string association name, this static method returns an integer association type for the attribute (i.e. More...
static vtkInformationStringKey * | DATA_TYPE_NAME ()
static vtkInformationDataObjectKey * | DATA_OBJECT ()
static vtkInformationIntegerKey * | DATA_EXTENT_TYPE ()
static vtkInformationIntegerPointerKey * | DATA_EXTENT ()
static vtkInformationIntegerVectorKey * | ALL_PIECES_EXTENT ()
static vtkInformationIntegerKey * | DATA_PIECE_NUMBER ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_PIECES ()
static vtkInformationIntegerKey * | DATA_NUMBER_OF_GHOST_LEVELS ()
static vtkInformationDoubleKey * | DATA_TIME_STEP ()
static vtkInformationInformationVectorKey * | POINT_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | CELL_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | VERTEX_DATA_VECTOR ()
static vtkInformationInformationVectorKey * | EDGE_DATA_VECTOR ()
static vtkInformationIntegerKey * | FIELD_ARRAY_TYPE ()
static vtkInformationIntegerKey * | FIELD_ASSOCIATION ()
static vtkInformationIntegerKey * | FIELD_ATTRIBUTE_TYPE ()
static vtkInformationIntegerKey * | FIELD_ACTIVE_ATTRIBUTE ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_COMPONENTS ()
static vtkInformationIntegerKey * | FIELD_NUMBER_OF_TUPLES ()
static vtkInformationIntegerKey * | FIELD_OPERATION ()
static vtkInformationDoubleVectorKey * | FIELD_RANGE ()
static vtkInformationIntegerVectorKey * | PIECE_EXTENT ()
static vtkInformationStringKey * | FIELD_NAME ()
static vtkInformationDoubleVectorKey * | ORIGIN ()
static vtkInformationDoubleVectorKey * | SPACING ()
static vtkInformationDoubleVectorKey * | DIRECTION ()
static vtkInformationDoubleVectorKey * | BOUNDING_BOX ()
static vtkInformationDataObjectKey * | SIL ()
static vtkDataObject * | GetData (vtkInformation *info)
| Retrieve an instance of this class from an information object. More...
static vtkDataObject * | GetData (vtkInformationVector *v, int i=0)
| Retrieve an instance of this class from an information object. More...
static void | SetGlobalReleaseDataFlag (vtkTypeBool val)
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
static vtkTypeBool | GetGlobalReleaseDataFlag ()
| Turn on/off flag to control whether every object releases its data after being used by a filter. More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()

## Detailed Description

### template<class Implementation, class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>
class vtkMappedUnstructuredGrid< Implementation, CellIterator >

Allows datasets with arbitrary storage layouts to be used with VTK.

This class fulfills the vtkUnstructuredGridBase API while delegating to a arbitrary implementation of the dataset topology. The purpose of vtkMappedUnstructuredGrid is to allow external data structures to be used directly in a VTK pipeline, e.g. for in-situ analysis of a running simulation.

When introducing an external data structure into VTK, there are 3 principle components of the dataset to consider:

- Points
- Cells (topology)
- Point/Cell attributes

Points and attributes can be handled by subclassing vtkMappedDataArray and implementing that interface to adapt the external data structures into VTK. The vtkMappedDataArray subclasses can then be used as the vtkPoints's Data member (for points/nodes) or added directly to vtkPointData, vtkCellData, or vtkFieldData for attribute information. Filters used in the pipeline will need to be modified to remove calls to vtkDataArray::GetVoidPointer and use a suitable vtkArrayDispatch instead.

Introducing an arbitrary topology implementation into VTK requires the use of the vtkMappedUnstructuredGrid class. Unlike the data array counterpart, the mapped unstructured grid is not subclassed, but rather takes an adaptor class as a template argument. This is to allow cheap shallow copies of the data by passing the reference-counted implementation object to new instances of vtkMappedUnstructuredGrid.

The implementation class should derive from vtkObject (for reference counting) and implement the usual vtkObject API requirements, such as a static New() method and PrintSelf function. The following methods must also be implemented:

- vtkIdType GetNumberOfCells()
- int GetCellType(vtkIdType cellId)
- void GetCellPoints(vtkIdType cellId, vtkIdList *ptIds)
- void GetFaceStream(vtkIdType cellId, vtkIdList *ptIds)
- void GetPointCells(vtkIdType ptId, vtkIdList *cellIds)
- int GetMaxCellSize()
- void GetIdsOfCellsOfType(int type, vtkIdTypeArray *array)
- int IsHomogeneous()
- void Allocate(vtkIdType numCells, int extSize = 1000)
- vtkIdType InsertNextCell(int type, vtkIdList *ptIds)
- vtkIdType InsertNextCell(int type, vtkIdType npts, const vtkIdType ptIds[])
- vtkIdType InsertNextCell(int type, vtkIdType npts, const vtkIdType ptIds[], vtkIdType nfaces, const int faces[])
- void ReplaceCell(vtkIdType cellId, int npts, const vtkIdType pts[])

These methods should provide the same functionality as defined in vtkUnstructuredGrid. See that class's documentation for more information.

Note that since the implementation class is used as a compile-time template parameter in vtkMappedUnstructuredGrid, the above methods do not need be virtuals. The compiler will statically bind the calls, making dynamic vtable lookups unnecessary and giving a slight performance boost.

Adapting a filter or algorithm to safely traverse the vtkMappedUnstructuredGrid's topology requires removing calls the following implementation-dependent vtkUnstructuredGrid methods:

- vtkUnstructuredGrid::GetCellTypesArray()
- vtkUnstructuredGrid::GetCellLocationsArray()
- vtkUnstructuredGrid::GetCellLinks()
- vtkUnstructuredGrid::GetCells() Access to the values returned by these methods should be replaced by the equivalent random-access lookup methods in the vtkUnstructuredGridBase API, or use vtkCellIterator (see vtkDataSet::NewCellIterator) for sequential access.

A custom vtkCellIterator implementation may be specified for a particular vtkMappedUnstructuredGrid as the second template parameter. By default, vtkMappedUnstructuredGridCellIterator will be used, which increments an internal cell id counter and performs random-access lookup as-needed. More efficient implementations may be used with data structures better suited for sequential access, see vtkUnstructuredGridCellIterator for an example.

A set of four macros are provided to generate a concrete subclass of vtkMappedUnstructuredGrid with a specified implementation, cell iterator, and export declaration. They are:

- vtkMakeMappedUnstructuredGrid(_className, _impl)
  - Create a subclass of vtkMappedUnstructuredGrid using _impl implementation that is named _className.
- vtkMakeMappedUnstructuredGridWithIter(_className, _impl, _cIter)
  - Create a subclass of vtkMappedUnstructuredGrid using _impl implementation and _cIter vtkCellIterator that is named _className.
- vtkMakeExportedMappedUnstructuredGrid(_className, _impl, _exportDecl)
  - Create a subclass of vtkMappedUnstructuredGrid using _impl implementation that is named _className. _exportDecl is used to decorate the class declaration.
- vtkMakeExportedMappedUnstructuredGridWithIter(_className, _impl, _cIter, _exportDecl)
  - Create a subclass of vtkMappedUnstructuredGrid using _impl implementation and _cIter vtkCellIterator that is named _className. _exportDecl is used to decorate the class declaration.

To instantiate a vtkMappedUnstructuredGrid subclass created by the above macro, the follow pattern is encouraged:

MyGrid.h:
----------------------------------------------------------------------
class MyGridImplementation : public vtkObject
{
public:
... (vtkObject required API) ...
... (vtkMappedUnstructuredGrid Implementation required API) ...
void SetImplementationDetails(...raw data from external source...);
};
vtkMakeMappedUnstructuredGrid(MyGrid, MyGridImplementation)
SomeSource.cxx
----------------------------------------------------------------------
vtkNew<MyGrid> grid;
grid->GetImplementation()->SetImplementationDetails(...);
// grid is now ready to use.
vtkMappedUnstructuredGrid
Allows datasets with arbitrary storage layouts to be used with VTK.
Definition: vtkMappedUnstructuredGrid.h:144
vtkNew
Allocate and hold a VTK object.
Definition: vtkNew.h:60
vtkObject
abstract base class for most VTK objects
Definition: vtkObject.h:61
vtkX3D::data
@ data
Definition: vtkX3D.h:315
source
boost::graph_traits< vtkGraph * >::vertex_descriptor source(boost::graph_traits< vtkGraph * >::edge_descriptor e, vtkGraph *)
Definition: vtkBoostGraphAdapter.h:964
vtkMakeMappedUnstructuredGrid
#define vtkMakeMappedUnstructuredGrid(_className, _impl)
Definition: vtkMappedUnstructuredGrid.h:281

The vtkCPExodusIIElementBlock class provides an example of vtkMappedUnstructuredGrid usage, adapting the Exodus II data structures for the VTK pipeline.

Tests:
  vtkMappedUnstructuredGrid (Tests)

Definition at line 143 of file vtkMappedUnstructuredGrid.h.

## Member Typedef Documentation

## ◆ ImplementationType

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

typedef Implementation vtkMappedUnstructuredGrid< Implementation, CellIterator >::ImplementationType

Definition at line 149 of file vtkMappedUnstructuredGrid.h.

## ◆ CellIteratorType

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

typedef CellIterator vtkMappedUnstructuredGrid< Implementation, CellIterator >::CellIteratorType

Definition at line 150 of file vtkMappedUnstructuredGrid.h.

## ◆ ThisType

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

typedef vtkMappedUnstructuredGrid<Implementation, CellIterator> vtkMappedUnstructuredGrid< Implementation, CellIterator >::ThisType
| protected

Definition at line 178 of file vtkMappedUnstructuredGrid.h.

## Constructor & Destructor Documentation

## ◆ vtkMappedUnstructuredGrid()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkMappedUnstructuredGrid< Implementation, CellIterator >::vtkMappedUnstructuredGrid | ( |  | ) |
| protected

## ◆ ~vtkMappedUnstructuredGrid()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkMappedUnstructuredGrid< Implementation, CellIterator >::~vtkMappedUnstructuredGrid | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ vtkTemplateTypeMacro()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkMappedUnstructuredGrid< Implementation, CellIterator >::vtkTemplateTypeMacro | ( | SelfType | ,
|  | vtkUnstructuredGridBase |
| ) |  |

## ◆ PrintSelf()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Methods invoked by print to print information about the object including superclasses.

Typically not called by the user (use Print() instead) but used in the hierarchical print process to combine the output of several classes.

Reimplemented from vtkDataSet.

## ◆ CopyStructure()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::CopyStructure | ( | vtkDataSet * | ds | ) |
| overridevirtual

Copy the geometric and topological structure of an object.

Note that the invoking object and the object pointed to by the parameter ds must be of the same type. THIS METHOD IS NOT THREAD SAFE.

Implements vtkDataSet.

## ◆ ShallowCopy()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::ShallowCopy | ( | vtkDataObject * | src | ) |
| overridevirtual

Shallow and Deep copy.

Reimplemented from vtkDataSet.

## ◆ GetNumberOfCells()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkIdType vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetNumberOfCells | ( |  | ) |
| overridevirtual

Determine the number of cells composing the dataset.

THIS METHOD IS THREAD SAFE

Implements vtkDataSet.

## ◆ GetCell() [1/5]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkCell* vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetCell | ( | vtkIdType | cellId | ) |
| overridevirtual

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

The returned vtkCell is an object owned by this instance, hence the return value must not be deleted by the caller.

Warning
  Repeat calls to this function for different face ids will change the data stored in the internal member object whose pointer is returned by this function.
  THIS METHOD IS NOT THREAD SAFE. For a thread-safe version, please use void GetCell(vtkIdType cellId, vtkGenericCell* cell).

Implements vtkDataSet.

## ◆ GetCell() [2/5]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetCell | ( | vtkIdType | cellId,
|  | vtkGenericCell * | cell
| ) |  |
| overridevirtual

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

This is a thread-safe alternative to the previous GetCell() method. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implements vtkDataSet.

## ◆ GetCellType()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

int vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetCellType | ( | vtkIdType | cellId | ) |
| overridevirtual

Get type of cell with cellId such that: 0 <= cellId < NumberOfCells.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implements vtkDataSet.

## ◆ GetCellPoints()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetCellPoints | ( | vtkIdType | cellId,
|  | vtkIdList * | ptIds
| ) |  |
| overridevirtual

Topological inquiry to get points defining cell.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implements vtkDataSet.

## ◆ NewCellIterator()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkCellIterator* vtkMappedUnstructuredGrid< Implementation, CellIterator >::NewCellIterator | ( |  | ) |
| overridevirtual

Return an iterator that traverses the cells in this data set.

Reimplemented from vtkDataSet.

## ◆ GetPointCells()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetPointCells | ( | vtkIdType | ptId,
|  | vtkIdList * | cellIds
| ) |  |
| overridevirtual

Topological inquiry to get cells using point.

THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

Implements vtkDataSet.

## ◆ GetMaxCellSize()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

int vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetMaxCellSize | ( |  | ) |
| overridevirtual

Convenience method returns largest cell size in dataset.

This is generally used to allocate memory for supporting data structures. THIS METHOD IS THREAD SAFE

Implements vtkDataSet.

## ◆ GetIdsOfCellsOfType()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetIdsOfCellsOfType | ( | int | type,
|  | vtkIdTypeArray * | array
| ) |  |
| overridevirtual

Fill vtkIdTypeArray container with list of cell Ids.

This method traverses all cells and, for a particular cell type, inserts the cell Id into the container.

Implements vtkUnstructuredGridBase.

## ◆ IsHomogeneous()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

int vtkMappedUnstructuredGrid< Implementation, CellIterator >::IsHomogeneous | ( |  | ) |
| overridevirtual

Traverse cells and determine if cells are all of the same type.

Implements vtkUnstructuredGridBase.

## ◆ Allocate()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::Allocate | ( | vtkIdType | numCells,
|  | int | extSize = `1000`
| ) |  |
| overridevirtual

Allocate memory for the number of cells indicated.

extSize is not used.

Implements vtkUnstructuredGridBase.

## ◆ GetMTime()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkMTimeType vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetMTime | ( |  | ) |
| overridevirtual

Datasets are composite objects and need to check each part for MTime THIS METHOD IS THREAD SAFE.

Reimplemented from vtkDataSet.

## ◆ SetImplementation()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::SetImplementation | ( | ImplementationType * | impl | ) |

## ◆ GetImplementation()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

ImplementationType* vtkMappedUnstructuredGrid< Implementation, CellIterator >::GetImplementation | ( |  | ) |

## ◆ InternalInsertNextCell() [1/3]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkIdType vtkMappedUnstructuredGrid< Implementation, CellIterator >::InternalInsertNextCell | ( | int | type,
|  | vtkIdType | npts,
|  | const vtkIdType | ptIds[]
| ) |  |
| overrideprotectedvirtual

Implements vtkUnstructuredGridBase.

## ◆ InternalInsertNextCell() [2/3]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkIdType vtkMappedUnstructuredGrid< Implementation, CellIterator >::InternalInsertNextCell | ( | int | type,
|  | vtkIdList * | ptIds
| ) |  |
| overrideprotectedvirtual

Implements vtkUnstructuredGridBase.

## ◆ InternalInsertNextCell() [3/3]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkIdType vtkMappedUnstructuredGrid< Implementation, CellIterator >::InternalInsertNextCell | ( | int | type,
|  | vtkIdType | npts,
|  | const vtkIdType | ptIds[],
|  | vtkIdType | nfaces,
|  | const vtkIdType | faces[]
| ) |  |
| overrideprotectedvirtual

Implements vtkUnstructuredGridBase.

## ◆ InternalReplaceCell()

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

void vtkMappedUnstructuredGrid< Implementation, CellIterator >::InternalReplaceCell | ( | vtkIdType | cellId,
|  | int | npts,
|  | const vtkIdType | pts[]
| ) |  |
| overrideprotectedvirtual

Implements vtkUnstructuredGridBase.

## ◆ GetCell() [3/5]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

virtual vtkCell* vtkDataSet::GetCell

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

The returned vtkCell is an object owned by this instance, hence the return value must not be deleted by the caller.

Warning
  Repeat calls to this function for different face ids will change the data stored in the internal member object whose pointer is returned by this function.
  THIS METHOD IS NOT THREAD SAFE. For a thread-safe version, please use void GetCell(vtkIdType cellId, vtkGenericCell* cell).

## ◆ GetCell() [4/5]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

virtual vtkCell* vtkDataSet::GetCell
| inline

Definition at line 127 of file vtkDataSet.h.

## ◆ GetCell() [5/5]

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

virtual void vtkDataSet::GetCell

Get cell with cellId such that: 0 <= cellId < NumberOfCells.

This is a thread-safe alternative to the previous GetCell() method. THIS METHOD IS THREAD SAFE IF FIRST CALLED FROM A SINGLE THREAD AND THE DATASET IS NOT MODIFIED

## Member Data Documentation

## ◆ Impl

template<class Implementation , class CellIterator = vtkMappedUnstructuredGridCellIterator<Implementation>>

vtkSmartPointer<ImplementationType> vtkMappedUnstructuredGrid< Implementation, CellIterator >::Impl
| protected

Definition at line 180 of file vtkMappedUnstructuredGrid.h.

The documentation for this class was generated from the following file:

- Common/DataModel/vtkMappedUnstructuredGrid.h